% table1ldtest.m

% Ron Alquist

% Bank of Canada

% January 2009


% This program returns the entries of the local drift forecasts in Table 1 of of Alquist

% and Kilian's "What Do We Learn From the Price of Crude Oil Futures?"

clear all;

format short g;

load prices.txt;

load dslag.txt

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Variable names

date = prices(:,1:2);

s = prices(:,3);

ds1mlag = dslag(:,3);

ds3mlag = dslag(:,4);

ds6mlag = dslag(:,5);

ds9mlag = dslag(:,6);

ds12mlag = dslag(:,7);

sf1mld = s.*ds1mlag;

sf3mld = s.*ds3mlag;

sf6mld = s.*ds6mlag;

sf9mld = s.*ds9mlag;

sf12mld = s.*ds12mlag;

B = 999;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('1-month ahead forecast with 1-month local drift');

[mspe,msperat,mspepvaladj,bias] = mspecw(s,sf1mld,1,1990,date);

[mapeout,maperat,mapepval] = bsmapeld(s,sf1mld,1,1,1990,date,B);

[sr,srpval] = nrbpt(s,sf1mld,1,1990,date);

disp('MSPE ratio:');

disp(msperat);

disp('MSPE p-value:');

disp(mspepvaladj);

disp('Bias:');

disp(bias);

disp('MAPE ratio:');

disp(maperat);

disp('MAPE p-value:');

disp(mapepval);

disp('Success ratio:');

disp(sr);

disp('SR p-value:');

disp(srpval);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('1-month ahead forecast with 3-month local drift');

[mspe,msperat,mspepvaladj,bias] = mspecw(s,sf3mld,1,1990,date);

[mapeout,maperat,mapepval] = bsmapeld(s,sf3mld,3,1,1990,date,B);

[sr,srpval] = nrbpt(s,sf3mld,1,1990,date);

disp('MSPE ratio:');

disp(msperat);

disp('MSPE p-value:');

disp(mspepvaladj);

disp('Bias:');

disp(bias);

disp('MAPE ratio:');

disp(maperat);

disp('MAPE p-value:');

disp(mapepval);

disp('Success ratio:');

disp(sr);

disp('SR p-value:');

disp(srpval);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('1-month ahead forecast with 6-month local drift');

[mspe,msperat,mspepvaladj,bias] = mspecw(s,sf6mld,1,1990,date);

[mapeout,maperat,mapepval] = bsmapeld(s,sf6mld,6,1,1990,date,B);

[sr,srpval] = nrbpt(s,sf6mld,1,1990,date);

disp('MSPE ratio:');

disp(msperat);

disp('MSPE p-value:');

disp(mspepvaladj);

disp('Bias:');

disp(bias);

disp('MAPE ratio:');

disp(maperat);

disp('MAPE p-value:');

disp(mapepval);

disp('Success ratio:');

disp(sr);

disp('SR p-value:');

disp(srpval);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('1-month ahead forecast with 9-month local drift');

[mspe,msperat,mspepvaladj,bias] = mspecw(s,sf9mld,1,1990,date);

[mapeout,maperat,mapepval] = bsmapeld(s,sf9mld,9,1,1990,date,B);

[sr,srpval] = nrbpt(s,sf9mld,1,1990,date);

disp('MSPE ratio:');

disp(msperat);

disp('MSPE p-value:');

disp(mspepvaladj);

disp('Bias:');

disp(bias);

disp('MAPE ratio:');

disp(maperat);

disp('MAPE p-value:');

disp(mapepval);

disp('Success ratio:');

disp(sr);

disp('SR p-value:');

disp(srpval);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('1-month ahead forecast with 12-month local drift');

[mspe,msperat,mspepvaladj,bias] = mspecw(s,sf12mld,1,1990,date);

[mapeout,maperat,mapepval] = bsmapeld(s,sf12mld,12,1,1990,date,B);

[sr,srpval] = nrbpt(s,sf12mld,1,1990,date);

disp('MSPE ratio:');

disp(msperat);

disp('MSPE p-value:');

disp(mspepvaladj);

disp('Bias:');

disp(bias);

disp('MAPE ratio:');

disp(maperat);

disp('MAPE p-value:');

disp(mapepval);

disp('Success ratio:');

disp(sr);

disp('SR p-value:');

disp(srpval);