% table8a.m

% Ron Alquist

% Bank of Canada

% January 2009


% This program returns the entries in Table 8a of Alquist and Kilian's "What Do We Learn From the Price of

% Crude Oil Futures?"

clear all;

format short g;

load prices.txt;

date = prices(:,1:2);

s = prices(:,3);

f1m = prices(:,4);

f3m = prices(:,5);

f6m = prices(:,6);

f9m = prices(:,7);

f12m = prices(:,8);

% Bias of 1-month futures price

bias1m = [date(2:end,:) 100*(f1m(1:end-1,1)./s(2:end,1) - 1)];

b = find(bias1m(:,1)==1991 & bias1m(:,2)==1);

e = find(bias1m(:,1)==2007 & bias1m(:,2)==2);

bias1m1 = bias1m(b:e,:);

y = bias1m1(:,3);

X = [ones(rows(bias1m1),1)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

alphapval = 2*normcdf(alphatstat);

disp('Bias of 1-month futures price relative actual spot price');

disp('The bias is:');

disp(bhat);

disp('The p-value is:');

disp(alphapval);

% Bias of 3-month futures price

bias3m = [date(4:end,:) 100*(f3m(1:end-3,1)./s(4:end,1) - 1)];

b = find(bias3m(:,1)==1991 & bias3m(:,2)==1);

e = find(bias3m(:,1)==2007 & bias3m(:,2)==2);

bias3m1 = bias3m(b:e,:);

y = bias3m1(:,3);

X = [ones(rows(bias3m1),1)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

alphapval = 2*normcdf(alphatstat);

disp('Bias of 3-month futures price relative actual spot price');

disp('The bias is:');

disp(bhat);

disp('The p-value is:');

disp(alphapval);

% Bias of 6-month futures price

bias6m = [date(7:end,:) 100*(f6m(1:end-6,1)./s(7:end,1) - 1)];

b = find(bias6m(:,1)==1991 & bias6m(:,2)==1);

e = find(bias6m(:,1)==2007 & bias6m(:,2)==2);

bias6m1 = bias6m(b:e,:);

y = bias6m1(:,3);

X = [ones(rows(bias6m1),1)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

alphapval = 2*normcdf(alphatstat);

disp('Bias of 6-month futures price relative actual spot price');

disp('The bias is:');

disp(bhat);

disp('The p-value is:');

disp(alphapval);

% Bias of 9-month futures price

bias9m = [date(10:end,:) 100*(f9m(1:end-9,1)./s(10:end,1) - 1)];

b = find(bias9m(:,1)==1991 & bias9m(:,2)==1);

e = find(bias9m(:,1)==2007 & bias9m(:,2)==2);

bias9m1 = bias9m(b:e,:);

y = bias9m1(:,3);

X = [ones(rows(bias9m1),1)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

alphapval = 2*normcdf(alphatstat);

disp('Bias of 9-month futures price relative actual spot price');

disp('The bias is:');

disp(bhat);

disp('The p-value is:');

disp(alphapval);

% Bias of 12-month futures price

bias12m = [date(13:end,:) 100*(f12m(1:end-12,1)./s(13:end,1) - 1)];

b = find(bias12m(:,1)==1991 & bias12m(:,2)==1);

e = find(bias12m(:,1)==2007 & bias12m(:,2)==2);

bias12m1 = bias12m(b:e,:);

y = bias12m1(:,3);

X = [ones(rows(bias12m1),1)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

alphapval = 2*normcdf(alphatstat);

disp('Bias of 12-month futures price relative actual spot price');

disp('The bias is:');

disp(bhat);

disp('The p-value is:');

disp(alphapval);