% table8b.m

% Ron Alquist

% Bank of Canada

% January 2009


% This program returns the entries in Table 8b of Alquist and Kilian's "What Do We Learn From the Price of

% Crude Oil Futures?"

clear all;

format short g;

load prices.txt;

date = prices(:,1:2);

s = prices(:,3);

f1m = prices(:,4);

f3m = prices(:,5);

f6m = prices(:,6);

f9m = prices(:,7);

f12m = prices(:,8);

% 1-month regression

ls1m = log(s(2:rows(s),1));

mat1m = [date(2:rows(date),:) ls1m log(f1m(1:rows(f1m)-1,1))];

b = find(mat1m(:,1)==1989 & mat1m(:,2)==1);

e = find(mat1m(:,1)==2007 & mat1m(:,2)==2);

mat1m1 = mat1m(b:e,:);

y = mat1m1(:,3);

X = [ones(rows(mat1m1),1) mat1m1(:,4)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

betatstat = (bhat(2,:)-1)/rbstderr(2,:);

alphapval = 2*(1 - normcdf(abs(alphatstat)));

betapval = 2*(1 - normcdf(abs(betatstat)));

disp('1-month predictive regression');

disp('The point estimate of alpha is:');

disp(bhat(1,:));

disp('The p-value for the test that alpha = 0 is:');

disp(alphapval);

disp('The point estimate of beta is:');

disp(bhat(2,:));

disp('The p-value for the test that beta = 1 is:');

disp(betapval);

% 3-month regression

ls3m = log(s(4:rows(s),1));

mat3m = [date(4:rows(date),:) ls3m log(f3m(1:rows(f3m)-3,1))];

b=find(mat3m(:,1)==1989 & mat3m(:,2)==1);

e=find(mat3m(:,1)==2007 & mat3m(:,2)==2);

mat3m1 = mat3m(b:e,:);

y = mat3m1(:,3);

X = [ones(rows(mat3m1),1) mat3m1(:,4)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

betatstat = (bhat(2,:)-1)/rbstderr(2,:);

alphapval = 2*(1 - normcdf(abs(alphatstat)));

betapval = 2*(1 - normcdf(abs(betatstat)));

disp('3-month predictive regression');

disp('The point estimate of alpha is:');

disp(bhat(1,:));

disp('The p-value for the test that alpha = 0 is:');

disp(alphapval);

disp('The point estimate of beta is:');

disp(bhat(2,:));

disp('The p-value for the test that beta = 1 is:');

disp(betapval);

% 6-month regression

ls6m = log(s(7:rows(s),1));

mat6m = [date(7:rows(date),:) ls6m log(f6m(1:rows(f6m)-6,1))];

b=find(mat6m(:,1)==1989 & mat6m(:,2)==1);

e=find(mat6m(:,1)==2007 & mat6m(:,2)==2);

mat6m1 = mat6m(b:e,:);

y = mat6m1(:,3);

X = [ones(rows(mat6m1),1) mat6m1(:,4)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

betatstat = (bhat(2,:)-1)/rbstderr(2,:);

alphapval = 2*(1 - normcdf(abs(alphatstat)));

betapval = 2*(1 - normcdf(abs(betatstat)));

disp('6-month predictive regression');

disp('The point estimate of alpha is:');

disp(bhat(1,:));

disp('The p-value for the test that alpha = 0 is:');

disp(alphapval);

disp('The point estimate of beta is:');

disp(bhat(2,:));

disp('The p-value for the test that beta = 1 is:');

disp(betapval);

% 9-month regression

ls9m = log(s(10:rows(s),1));

mat9m = [date(10:rows(date),:) ls9m log(f9m(1:rows(f9m)-9,1))];

b=find(mat9m(:,1)==1989 & mat9m(:,2)==1);

e=find(mat9m(:,1)==2007 & mat9m(:,2)==2);

mat9m1 = mat9m(b:e,:);

y = mat9m1(:,3);

X = [ones(rows(mat9m1),1) mat9m1(:,4)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

betatstat = (bhat(2,:)-1)/rbstderr(2,:);

alphapval = 2*(1 - normcdf(abs(alphatstat)));

betapval = 2*(1 - normcdf(abs(betatstat)));

disp('9-month predictive regression');

disp('The point estimate of alpha is:');

disp(bhat(1,:));

disp('The p-value for the test that alpha = 0 is:');

disp(alphapval);

disp('The point estimate of beta is:');

disp(bhat(2,:));

disp('The p-value for the test that beta = 1 is:');

disp(betapval);

% 12-month regression

ls12m = log(s(13:rows(s),1));

mat12m = [date(13:rows(date),:) ls12m log(f12m(1:rows(f12m)-12,1))];

b=find(mat12m(:,1)==1990 & mat12m(:,2)==1);

e=find(mat12m(:,1)==2007 & mat12m(:,2)==2);

mat12m1 = mat12m(b:e,:);

y = mat12m1(:,3);

X = [ones(rows(mat12m1),1) mat12m1(:,4)];

[bhat,bhatstd,tbhat,yhat,ehat] = ols(y,X);

t = rows(y);

nlag = round(4*((t/100)^(2/9)));

[rbstderr] = nwesterr(y,X,nlag);

alphatstat = bhat(1,:)/rbstderr(1,:);

betatstat = (bhat(2,:)-1)/rbstderr(2,:);

alphapval = 2*(1 - normcdf(abs(alphatstat)));

betapval = 2*(1 - normcdf(abs(betatstat)));

disp('12-month predictive regression');

disp('The point estimate of alpha is:');

disp(bhat(1,:));

disp('The p-value for the test that alpha = 0 is:');

disp(alphapval);

disp('The point estimate of beta is:');

disp(bhat(2,:));

disp('The p-value for the test that beta = 1 is:');

disp(betapval);