% table8c.m

% Ron Alquist

% Bank of Canada

% January 2009


% This program returns the entries in Table 8c of Alquist and Kilian's "What Do We Learn From the Price of

% Crude Oil Futures?"

clear all;

format short g;

load prices.txt;

date = prices(:,1:2);

s = prices(:,3);

f1m = prices(:,4);

f3m = prices(:,5);

f6m = prices(:,6);

f9m = prices(:,7);

f12m = prices(:,8);

% 1-month futures price versus RW

fehat1m = [date(2:end,:) s(2:end,1)-f1m(1:end-1,1) s(2:end,1)-s(1:end-1,1)];

b = find(fehat1m(:,1)==1991 & fehat1m(:,2)==1);

e = find(fehat1m(:,1)==2007 & fehat1m(:,2)==2);

fehat1m1 = fehat1m(b:e,:);

dmspe1m = fehat1m1(:,3).^2 - fehat1m1(:,4).^2;

nlag1m = round(4*((rows(dmspe1m)/100)^(2/9)));

f0hat1m = nwesterr(dmspe1m,ones(rows(dmspe1m),1),nlag1m);

dbarmspe1m = mean(dmspe1m);

dmmspe1m = dbarmspe1m/f0hat1m;

pval1m = 1 - normcdf(dmmspe1m,0,1);

disp('1-month futures price versus RW');

disp('The p-value is:')

disp(pval1m);

% 3-month futures price versus RW

fehat3m = [date(4:end,:) s(4:end,1)-f3m(1:end-3,1) s(4:end,1)-s(1:end-3,1)];

b = find(fehat3m(:,1)==1991 & fehat3m(:,2)==1);

e = find(fehat3m(:,1)==2007 & fehat3m(:,2)==2);

fehat3m1 = fehat3m(b:e,:);

dmspe3m = fehat3m1(:,3).^2 - fehat3m1(:,4).^2;

nlag3m = round(4*((rows(dmspe3m)/100)^(2/9)));

f0hat3m = nwesterr(dmspe3m,ones(rows(dmspe3m),1),nlag3m);

dbarmspe3m = mean(dmspe3m);

dmmspe3m = dbarmspe3m/f0hat3m;

pval3m = 1 - normcdf(dmmspe3m,0,1);

disp('3-month futures price versus RW');

disp('The p-value is:')

disp(pval3m);

% 6-month futures price versus RW

fehat6m = [date(7:end,:) s(7:end,1)-f6m(1:end-6,1) s(7:end,1)-s(1:end-6,1)];

b = find(fehat6m(:,1)==1991 & fehat6m(:,2)==1);

e = find(fehat6m(:,1)==2007 & fehat6m(:,2)==2);

fehat6m1 = fehat6m(b:e,:);

dmspe6m = fehat6m1(:,3).^2 - fehat6m1(:,4).^2;

nlag6m = round(4*((rows(dmspe6m)/100)^(2/9)));

f0hat6m = nwesterr(dmspe6m,ones(rows(dmspe6m),1),nlag6m);

dbarmspe6m = mean(dmspe6m);

dmmspe6m = dbarmspe6m/f0hat6m;

pval6m = 1 - normcdf(dmmspe6m,0,1);

disp('6-month futures price versus RW');

disp('The p-value is:');

disp(pval6m);

% 9-month futures price versus RW

fehat9m = [date(10:end,:) s(10:end,1)-f9m(1:end-9,1) s(10:end,1)-s(1:end-9,1)];

b = find(fehat9m(:,1)==1991 & fehat9m(:,2)==1);

e = find(fehat9m(:,1)==2007 & fehat9m(:,2)==2);

fehat9m1 = fehat9m(b:e,:);

dmspe9m = fehat9m1(:,3).^2 - fehat9m1(:,4).^2;

nlag9m = round(4*((rows(dmspe9m)/100)^(2/9)));

f0hat9m = nwesterr(dmspe9m,ones(rows(dmspe9m),1),nlag9m);

dbarmspe9m = mean(dmspe9m);

dmmspe9m = dbarmspe9m/f0hat9m;

pval9m = 1 - normcdf(dmmspe9m,0,1);

disp('9-month futures price versus RW');

disp('The p-value is:');

disp(pval9m);

% 12-month futures price versus RW

fehat12m = [date(13:end,:) s(13:end,1)-f12m(1:end-12,1) s(13:end,1)-s(1:end-12,1)];

b = find(fehat12m(:,1)==1991 & fehat12m(:,2)==1);

e = find(fehat12m(:,1)==2007 & fehat12m(:,2)==2);

fehat12m1 = fehat12m(b:e,:);

dmspe12m = fehat12m1(:,3).^2 - fehat12m1(:,4).^2;

nlag12m = round(4*((rows(dmspe12m)/100)^(2/9)));

f0hat12m = nwesterr(dmspe12m,ones(rows(dmspe12m),1),nlag12m);

dbarmspe12m = mean(dmspe12m);

dmmspe12m = dbarmspe12m/f0hat12m;

pval12m = 1 - normcdf(dmmspe12m,0,1);

disp('12-month futures price versus RW');

disp('The p-value is:');

disp(pval12m);