% table9.m

% Ron Alquist

% Bank of Canada

% January 2009


% This program returns the entries in Table 9 of Alquist and Kilian's "What Do We Learn From the Price of

% Crude Oil Futures?"

clear all;

format short g;

load prices.txt;

load pd.txt;

pddm = pd(:,3) - mean(pd(:,3));

date = prices(:,1:2);

s = prices(:,3);

f3m = prices(:,5);

f6m = prices(:,6);

f9m = prices(:,7);

f12m = prices(:,8);

sprd3m = 100*(f3m - s)./s;

sprd6m = 100*(f6m - s)./s;

sprd9m = 100*(f9m - s)./s;

sprd12m = 100*(f12m - s)./s;

sprdmat = [date, sprd3m, sprd6m, sprd9m, sprd12m];

b = find(sprdmat(:,1)==1989 & sprdmat(:,2)==1);

e = find(sprdmat(:,1)==2006 & sprdmat(:,2)==12);

sprdmat1 = sprdmat(b:e,:);

corrmat1 = corrcoef([pddm, -sprdmat1(:,3:end)]);

disp('Sample period: 1989.1-2006.12')

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 3-month spread*(-1) is:')

disp(corrmat1(2,1));

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 6-month spread*(-1) is:')

disp(corrmat1(3,1));

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 9-month spread*(-1) is:')

disp(corrmat1(4,1));

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 12-month spread*(-1) is:')

disp(corrmat1(5,1));

%%%%%%%%%%%%%%%%%%%%%%%%%%

b = find(sprdmat(:,1)==1989 & sprdmat(:,2)==1);

e = find(sprdmat(:,1)==2003 & sprdmat(:,2)==12);

sprdmat2 = sprdmat(b:e,:);

corrmat2 = corrcoef([pddm(1:end-36,1), -sprdmat2(:,3:end)]);

disp('Sample period: 1989.1-2003.12')

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 3-month spread*(-1) is:')

disp(corrmat2(2,1));

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 6-month spread*(-1) is:')

disp(corrmat2(3,1));

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 9-month spread*(-1) is:')

disp(corrmat2(4,1));

disp('The correlation coefficient between the precautionary demand component of the real price of oil and 12-month spread*(-1) is:')

disp(corrmat2(5,1));